Debian Bug report logs - #686152
xorg server 1.12.3: xf86UnloadSubModule() hangs

version graph

Package: src:xorg-server; Maintainer for src:xorg-server is Debian X Strike Force <debian-x@lists.debian.org>;

Reported by: Stephan Schreiber <info@fs-driver.org>

Date: Wed, 29 Aug 2012 09:06:01 UTC

Severity: serious

Tags: patch

Found in version xorg-server/2:1.12.3-1

Fixed in version xorg-server/2:1.12.4-1

Done: Julien Cristau <jcristau@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#686152; Package src:xorg-server. (Wed, 29 Aug 2012 09:06:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stephan Schreiber <info@fs-driver.org>:
New Bug report received and forwarded. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Wed, 29 Aug 2012 09:06:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Stephan Schreiber <info@fs-driver.org>
To: submit@bugs.debian.org
Subject: xorg server 1.12.3: xf86UnloadSubModule() hangs
Date: Wed, 29 Aug 2012 11:02:05 +0200
Package: xorg-server
Source: xorg-server
Severity: serious
Tags: wheezy



Machine: Dell PowerEdge 3250
Processor: 2x Itanium Madison 1.5GHz 6M
Memory: 4G
Graphics: build-in ATI Rage XL
01:01.0 VGA compatible controller [0300]: Advanced Micro Devices [AMD]
nee ATI Rage XL [1002:4752] (rev 27)
	Subsystem: Intel Corporation Device [8086:3404]



Hello,

I tried wheezy and experienced that the xorg server hangs upon  
startup. The screen is blank; switching to another console isn't  
possible.
The Xorg.0.log file reads:

[   157.058]
X.Org X Server 1.12.3
Release Date: 2012-07-09
[   157.059] X Protocol Version 11, Revision 0
[   157.059] Build Operating System: Linux 2.6.26-2-itanium ia64 Debian
[   157.059] Current Operating System: Linux itanic 3.2.0-3-mckinley  
#1 SMP Sat Aug 18 20:50:43 UTC 2012 ia64
[   157.059] Kernel command line: BOOT_IMAGE=scsi0:/EFI/debian/vmlinuz  
root=/dev/sdb5  nofb ro
[   157.059] Build Date: 24 August 2012  10:10:04PM
[   157.059] xorg-server 2:1.12.3-1 (Julien Cristau <jcristau@debian.org>)
[   157.059] Current version of pixman: 0.26.0
[   157.059] 	Before reporting problems, check http://wiki.x.org
	to make sure that you have the latest version.
[   157.059] Markers: (--) probed, (**) from config file, (==) default  
setting,
	(++) from command line, (!!) notice, (II) informational,
	(WW) warning, (EE) error, (NI) not implemented, (??) unknown.
[   157.060] (==) Log file: "/var/log/Xorg.0.log", Time: Sat Aug 25  
01:02:25 2012
[   157.069] (==) Using system config directory "/usr/share/X11/xorg.conf.d"
[   157.080] (==) No Layout section.  Using the first Screen section.
[   157.080] (==) No screen section available. Using defaults.
[   157.080] (**) |-->Screen "Default Screen Section" (0)
[   157.080] (**) |   |-->Monitor "<default monitor>"
[   157.080] (==) No monitor specified for screen "Default Screen Section".
	Using a default monitor configuration.
[   157.081] (==) Automatically adding devices
[   157.081] (==) Automatically enabling devices
[   157.121] (WW) The directory "/usr/share/fonts/X11/cyrillic" does  
not exist.
[   157.121] 	Entry deleted from font path.
[   157.121] (WW) The directory "/usr/share/fonts/X11/100dpi/" does not exist.
[   157.121] 	Entry deleted from font path.
[   157.121] (WW) The directory "/usr/share/fonts/X11/75dpi/" does not exist.
[   157.121] 	Entry deleted from font path.
[   157.121] (WW) The directory "/usr/share/fonts/X11/Type1" does not exist.
[   157.121] 	Entry deleted from font path.
[   157.121] (WW) The directory "/usr/share/fonts/X11/100dpi" does not exist.
[   157.121] 	Entry deleted from font path.
[   157.121] (WW) The directory "/usr/share/fonts/X11/75dpi" does not exist.
[   157.121] 	Entry deleted from font path.
[   157.121] (WW) The directory  
"/var/lib/defoma/x-ttcidfont-conf.d/dirs/TrueType" does not exist.
[   157.121] 	Entry deleted from font path.
[   157.121] (==) FontPath set to:
	/usr/share/fonts/X11/misc,
	built-ins
[   157.121] (==) ModulePath set to "/usr/lib/xorg/modules"
[   157.121] (II) The server relies on udev to provide the list of  
input devices.
	If no devices become available, reconfigure udev or disable AutoAddDevices.
[   157.121] (II) Loader magic: 0x20000008004321b0
[   157.122] (II) Module ABI versions:
[   157.122] 	X.Org ANSI C Emulation: 0.4
[   157.122] 	X.Org Video Driver: 12.0
[   157.122] 	X.Org XInput driver : 16.0
[   157.122] 	X.Org Server Extension : 6.0
[   157.123] (--) PCI:*(0:1:1:0) 1002:4752:8086:3404 rev 39, Mem @  
0xfb000000/16777216, 0xfaff0000/4096, I/O @ 0x0000cc00/256, BIOS @  
0x????????/131072
[   157.123] (II) Open ACPI successful (/var/run/acpid.socket)
[   157.123] (II) LoadModule: "extmod"
[   157.128] (II) Loading /usr/lib/xorg/modules/extensions/libextmod.so
[   157.129] (II) Module extmod: vendor="X.Org Foundation"
[   157.129] 	compiled for 1.12.3, module version = 1.0.0
[   157.129] 	Module class: X.Org Server Extension
[   157.129] 	ABI class: X.Org Server Extension, version 6.0
[   157.129] (II) Loading extension SELinux
[   157.129] (II) Loading extension MIT-SCREEN-SAVER
[   157.129] (II) Loading extension XFree86-VidModeExtension
[   157.129] (II) Loading extension XFree86-DGA
[   157.129] (II) Loading extension DPMS
[   157.129] (II) Loading extension XVideo
[   157.129] (II) Loading extension XVideo-MotionCompensation
[   157.129] (II) Loading extension X-Resource
[   157.129] (II) LoadModule: "dbe"
[   157.129] (II) Loading /usr/lib/xorg/modules/extensions/libdbe.so
[   157.129] (II) Module dbe: vendor="X.Org Foundation"
[   157.129] 	compiled for 1.12.3, module version = 1.0.0
[   157.129] 	Module class: X.Org Server Extension
[   157.129] 	ABI class: X.Org Server Extension, version 6.0
[   157.129] (II) Loading extension DOUBLE-BUFFER
[   157.129] (II) LoadModule: "glx"
[   157.130] (II) Loading /usr/lib/xorg/modules/extensions/libglx.so
[   157.130] (II) Module glx: vendor="X.Org Foundation"
[   157.130] 	compiled for 1.12.3, module version = 1.0.0
[   157.130] 	ABI class: X.Org Server Extension, version 6.0
[   157.130] (==) AIGLX enabled
[   157.130] (II) Loading extension GLX
[   157.130] (II) LoadModule: "record"
[   157.130] (II) Loading /usr/lib/xorg/modules/extensions/librecord.so
[   157.130] (II) Module record: vendor="X.Org Foundation"
[   157.131] 	compiled for 1.12.3, module version = 1.13.0
[   157.131] 	Module class: X.Org Server Extension
[   157.131] 	ABI class: X.Org Server Extension, version 6.0
[   157.131] (II) Loading extension RECORD
[   157.131] (II) LoadModule: "dri"
[   157.131] (II) Loading /usr/lib/xorg/modules/extensions/libdri.so
[   157.143] (II) Module dri: vendor="X.Org Foundation"
[   157.143] 	compiled for 1.12.3, module version = 1.0.0
[   157.143] 	ABI class: X.Org Server Extension, version 6.0
[   157.143] (II) Loading extension XFree86-DRI
[   157.143] (II) LoadModule: "dri2"
[   157.143] (II) Loading /usr/lib/xorg/modules/extensions/libdri2.so
[   157.143] (II) Module dri2: vendor="X.Org Foundation"
[   157.143] 	compiled for 1.12.3, module version = 1.2.0
[   157.143] 	ABI class: X.Org Server Extension, version 6.0
[   157.143] (II) Loading extension DRI2
[   157.143] (==) Matched ati as autoconfigured driver 0
[   157.143] (==) Matched fbdev as autoconfigured driver 1
[   157.143] (==) Assigned the driver to the xf86ConfigLayout
[   157.143] (II) LoadModule: "ati"
[   157.144] (II) Loading /usr/lib/xorg/modules/drivers/ati_drv.so
[   157.151] (II) Module ati: vendor="X.Org Foundation"
[   157.151] 	compiled for 1.12.1.902, module version = 6.14.4
[   157.151] 	Module class: X.Org Video Driver
[   157.151] 	ABI class: X.Org Video Driver, version 12.0
[   157.151] (II) LoadModule: "mach64"
[   157.151] (II) Loading /usr/lib/xorg/modules/drivers/mach64_drv.so
[   157.151] (II) Module mach64: vendor="X.Org Foundation"
[   157.151] 	compiled for 1.12.3, module version = 6.9.1
[   157.151] 	Module class: X.Org Video Driver
[   157.151] 	ABI class: X.Org Video Driver, version 12.0
[   157.151] (II) LoadModule: "fbdev"
[   157.152] (WW) Warning, couldn't open module fbdev
[   157.152] (II) UnloadModule: "fbdev"
[   157.152] (II) Unloading fbdev
[   157.152] (EE) Failed to load module "fbdev" (module does not exist, 0)
[   157.152] (II) MACH64: Driver for ATI Mach64 chipsets
[   157.152] (--) using VT number 7

[   157.155] (II) MACH64(0): Creating default Display subsection in  
Screen section
	"Default Screen Section" for depth/fbbpp 24/32
[   157.155] (==) MACH64(0): Depth 24, (--) framebuffer bpp 32
[   157.155] (==) MACH64(0): Using XAA acceleration architecture
[   157.155] (II) MACH64: Mach64 in slot 1:1:0 detected.
[   157.155] (II) Loading sub module "int10"
[   157.155] (II) LoadModule: "int10"
[   157.155] (II) Loading /usr/lib/xorg/modules/libint10.so
[   157.155] (II) Module int10: vendor="X.Org Foundation"
[   157.155] 	compiled for 1.12.3, module version = 1.0.0
[   157.155] 	ABI class: X.Org Video Driver, version 12.0
[   157.156] (WW) MACH64(0): Unable to retrieve all of segment 0x0C0000.
[   157.156] (II) Loading sub module "ddc"
[   157.156] (II) LoadModule: "ddc"
[   157.156] (II) Module "ddc" already built-in
[   157.156] (II) Loading sub module "vbe"
[   157.156] (II) LoadModule: "vbe"
[   157.156] (II) Loading /usr/lib/xorg/modules/libvbe.so
[   157.156] (II) Module vbe: vendor="X.Org Foundation"
[   157.156] 	compiled for 1.12.3, module version = 1.1.0
[   157.156] 	ABI class: X.Org Video Driver, version 12.0
[   157.156] (II) MACH64(0): VESA BIOS not detected
[   157.156] (II) UnloadSubModule: "vbe"
[   157.156] (II) Unloading vbe
[   157.157] (II) UnloadSubModule: "int10"
[   157.157] (II) Unloading int10
[   157.157] (II) UnloadSubModule: "cë"
[   157.157] (II) Unloading cë


I could figure out that the problem is in the xf86UnloadSubModule()  
function in hw/xfree86/common/xf86Helper.c of xorg-server-core 1.12.3:

void
xf86UnloadSubModule(pointer mod)
{
    UnloadSubModule(mod);
}

Earlier the function read in hw/xfree86/common/xf86Helper.c of  
xorg-server-core 1.11.4:

void
xf86UnloadSubModule(pointer mod)
{
    /*
     * This is disabled for now.  The loader isn't smart enough yet to undo
     * relocations.
     */
#if 0
    UnloadSubModule(mod);
#endif
}

Conclusion: UnloadSubModule() was and is still buggy.
I commented out UnloadSubModule(mod) tentative in 1.12.3, the X server  
started successful after that.

So the solution would be either comment out UnloadSubModule() or fix it...

Kind regards
Stephan Schreiber





Removed tag(s) wheezy. Request was from Julien Cristau <jcristau@debian.org> to control@bugs.debian.org. (Wed, 29 Aug 2012 09:15:13 GMT) Full text and rfc822 format available.

Marked as found in versions xorg-server/2:1.12.3-1. Request was from Julien Cristau <jcristau@debian.org> to control@bugs.debian.org. (Wed, 29 Aug 2012 09:18:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#686152; Package src:xorg-server. (Thu, 06 Sep 2012 16:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stephan Schreiber <info@fs-driver.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 06 Sep 2012 16:45:03 GMT) Full text and rfc822 format available.

Message #14 received at 686152@bugs.debian.org (full text, mbox):

From: Stephan Schreiber <info@fs-driver.org>
To: 686152@bugs.debian.org
Subject: xorg server 1.12.3: xf86UnloadSubModule() hangs, patch proposal
Date: Thu, 06 Sep 2012 18:31:52 +0200
[Message part 1 (text/plain, inline)]
A patch proposal.

The unpatched code is (hw/xfree86/loader/loadmod.c):

static void
UnloadModuleOrDriver(ModuleDescPtr mod)
{
    if (mod == (ModuleDescPtr) 1)
        return;

    if (mod == NULL || mod->name == NULL)
        return;

    if (mod->parent)
        xf86MsgVerb(X_INFO, 3, "UnloadSubModule: \"%s\"\n", mod->name);
    else
        xf86MsgVerb(X_INFO, 3, "UnloadModule: \"%s\"\n", mod->name);

    if (mod->TearDownData != ModuleDuplicated) {
        if ((mod->TearDownProc) && (mod->TearDownData))
            mod->TearDownProc(mod->TearDownData);
        LoaderUnload(mod->name, mod->handle);
    }

    if (mod->child)
        UnloadModuleOrDriver(mod->child);
    if (mod->sib)
        UnloadModuleOrDriver(mod->sib);
    free(mod->path);
    free(mod->name);
    free(mod);
}

void
UnloadSubModule(pointer _mod)
{
    ModuleDescPtr mod = (ModuleDescPtr) _mod;

    /* Some drivers are calling us on built-in submodules, ignore them */
    if (mod == (ModuleDescPtr) 1)
        return;
    RemoveChild(mod);
    UnloadModuleOrDriver(mod);
}

static void
RemoveChild(ModuleDescPtr child)
{
    ModuleDescPtr mdp;
    ModuleDescPtr prevsib;
    ModuleDescPtr parent;

    if (!child->parent)
        return;

    parent = child->parent;
    if (parent->child == child) {
        parent->child = child->sib;
        return;
    }

    prevsib = parent->child;
    mdp = prevsib->sib;
    while (mdp && mdp != child) {
        prevsib = mdp;
        mdp = mdp->sib;
    }
    if (mdp == child)
        prevsib->sib = child->sib;
    child->sib = NULL;
    return;
}


The UnloadSubModule() function is called by xf86UnloadSubModule() as  
you can see in my first report.
UnloadSubModule() first calls RemoveChild(), finally  
UnloadModuleOrDriver() for the submodule pointer to unload it.

As you can see, each ModuleDescPtr instance maintains its childs:
ptr->child is the first child,
ptr->child->sib is the second child,
prt->child->sib->sib is the third child
as long as ->child or ->sib isn't NULL.

The idea seems to be that UnloadSubModule() deals with modules that  
didn't unload their childs - in the TearDownProc that  
UnloadModuleOrDriver() calls.
Thus, UnloadModuleOrDriver() has the code lines which unload all  
childs and grand childs etc. recursively:
    if (mod->child)
        UnloadModuleOrDriver(mod->child);
    if (mod->sib)
        UnloadModuleOrDriver(mod->sib);

Note that the call of UnloadModuleOrDriver(mod->sib) is needed for  
that recursive unload.

The top-level instance of UnloadModuleOrDriver() gets the module  
pointer which UnloadSubModule() had.
The UnloadModuleOrDriver() function must not unload mod->sib for that  
top-level module pointer because it is a sibling of the module but not  
a child.
The call of UnloadModuleOrDriver(mod->sib) can't be removed because it  
would break the mentioned recursive unload.

Thus, RemoveChild() sets ->sib to NULL for the module pointer that it gets.

When UnloadSubModule() calls RemoveChild(), then  
UnloadModuleOrDriver() for the submodule to unload, everything works  
fine, because UnloadModuleOrDriver() detects the NULL ->sib pointer  
and won't call UnloadModuleOrDriver() in recursive manner for it.


The real bug is in RemoveChild() - it doesn't set ->sib to NULL if the  
module is the first child of its parent. This causes wrong and  
multiple unload attempts for particular submodules what hangs up the  
xorg server.


The patch corrects the RemoveChild() function:

static void
RemoveChild(ModuleDescPtr child)
{
    ModuleDescPtr mdp;
    ModuleDescPtr prevsib;
    ModuleDescPtr parent;

    if (!child->parent)
        return;

    parent = child->parent;
    if (parent->child == child) {
        parent->child = child->sib;
    }
    else {
        prevsib = parent->child;
        mdp = prevsib->sib;
        while (mdp && mdp != child) {
            prevsib = mdp;
            mdp = mdp->sib;
        }
        if (mdp == child)
            prevsib->sib = child->sib;
    }
    child->sib = NULL;
}




I built the xorg-xserver package with the patch (and the ones of  
bug#685750 and 686153).

It works; the resulting Xorg.0.log is:

[    31.839]
X.Org X Server 1.12.3
Release Date: 2012-07-09
[    31.839] X Protocol Version 11, Revision 0
[    31.839] Build Operating System: Linux 3.2.0-3-mckinley ia64 Debian
[    31.839] Current Operating System: Linux itanic 3.2.0-3-mckinley  
#1 SMP Sat Aug 18 20:50:43 UTC 2012 ia64
[    31.839] Kernel command line: BOOT_IMAGE=scsi0:/EFI/debian/vmlinuz  
root=/dev/sdb5  ro
[    31.839] Build Date: 05 September 2012  06:41:52PM
[    31.839] xorg-server 2:1.12.3-1 (Julien Cristau <jcristau@debian.org>)
[    31.839] Current version of pixman: 0.26.0
[    31.839] 	Before reporting problems, check http://wiki.x.org
	to make sure that you have the latest version.
[    31.840] Markers: (--) probed, (**) from config file, (==) default  
setting,
	(++) from command line, (!!) notice, (II) informational,
	(WW) warning, (EE) error, (NI) not implemented, (??) unknown.
[    31.840] (==) Log file: "/var/log/Xorg.0.log", Time: Wed Sep  5  
19:24:48 2012
[    31.886] (==) Using system config directory "/usr/share/X11/xorg.conf.d"
[    31.914] (==) No Layout section.  Using the first Screen section.
[    31.914] (==) No screen section available. Using defaults.
[    31.914] (**) |-->Screen "Default Screen Section" (0)
[    31.914] (**) |   |-->Monitor "<default monitor>"
[    31.915] (==) No monitor specified for screen "Default Screen Section".
	Using a default monitor configuration.
[    31.915] (==) Automatically adding devices
[    31.915] (==) Automatically enabling devices
[    31.955] (WW) The directory "/usr/share/fonts/X11/cyrillic" does  
not exist.
[    31.955] 	Entry deleted from font path.
[    31.955] (WW) The directory "/usr/share/fonts/X11/100dpi/" does not exist.
[    31.955] 	Entry deleted from font path.
[    31.955] (WW) The directory "/usr/share/fonts/X11/75dpi/" does not exist.
[    31.955] 	Entry deleted from font path.
[    31.955] (WW) The directory "/usr/share/fonts/X11/Type1" does not exist.
[    31.955] 	Entry deleted from font path.
[    31.955] (WW) The directory "/usr/share/fonts/X11/100dpi" does not exist.
[    31.955] 	Entry deleted from font path.
[    31.955] (WW) The directory "/usr/share/fonts/X11/75dpi" does not exist.
[    31.955] 	Entry deleted from font path.
[    31.955] (WW) The directory  
"/var/lib/defoma/x-ttcidfont-conf.d/dirs/TrueType" does not exist.
[    31.955] 	Entry deleted from font path.
[    31.956] (==) FontPath set to:
	/usr/share/fonts/X11/misc,
	built-ins
[    31.956] (==) ModulePath set to "/usr/lib/xorg/modules"
[    31.956] (II) The server relies on udev to provide the list of  
input devices.
	If no devices become available, reconfigure udev or disable AutoAddDevices.
[    31.956] (II) Loader magic: 0x20000008004321b0
[    31.956] (II) Module ABI versions:
[    31.956] 	X.Org ANSI C Emulation: 0.4
[    31.956] 	X.Org Video Driver: 12.0
[    31.956] 	X.Org XInput driver : 16.0
[    31.956] 	X.Org Server Extension : 6.0
[    31.965] (--) PCI:*(0:1:1:0) 1002:4752:8086:3404 rev 39, Mem @  
0xfb000000/16777216, 0xfaff0000/4096, I/O @ 0x0000cc00/256, BIOS @  
0x????????/131072
[    31.966] (II) Open ACPI successful (/var/run/acpid.socket)
[    31.966] (II) LoadModule: "extmod"
[    31.994] (II) Loading /usr/lib/xorg/modules/extensions/libextmod.so
[    32.004] (II) Module extmod: vendor="X.Org Foundation"
[    32.004] 	compiled for 1.12.3, module version = 1.0.0
[    32.004] 	Module class: X.Org Server Extension
[    32.004] 	ABI class: X.Org Server Extension, version 6.0
[    32.004] (II) Loading extension SELinux
[    32.004] (II) Loading extension MIT-SCREEN-SAVER
[    32.004] (II) Loading extension XFree86-VidModeExtension
[    32.004] (II) Loading extension XFree86-DGA
[    32.004] (II) Loading extension DPMS
[    32.004] (II) Loading extension XVideo
[    32.004] (II) Loading extension XVideo-MotionCompensation
[    32.004] (II) Loading extension X-Resource
[    32.004] (II) LoadModule: "dbe"
[    32.004] (II) Loading /usr/lib/xorg/modules/extensions/libdbe.so
[    32.005] (II) Module dbe: vendor="X.Org Foundation"
[    32.005] 	compiled for 1.12.3, module version = 1.0.0
[    32.005] 	Module class: X.Org Server Extension
[    32.005] 	ABI class: X.Org Server Extension, version 6.0
[    32.005] (II) Loading extension DOUBLE-BUFFER
[    32.005] (II) LoadModule: "glx"
[    32.005] (II) Loading /usr/lib/xorg/modules/extensions/libglx.so
[    32.040] (II) Module glx: vendor="X.Org Foundation"
[    32.040] 	compiled for 1.12.3, module version = 1.0.0
[    32.040] 	ABI class: X.Org Server Extension, version 6.0
[    32.040] (==) AIGLX enabled
[    32.040] (II) Loading extension GLX
[    32.040] (II) LoadModule: "record"
[    32.041] (II) Loading /usr/lib/xorg/modules/extensions/librecord.so
[    32.041] (II) Module record: vendor="X.Org Foundation"
[    32.041] 	compiled for 1.12.3, module version = 1.13.0
[    32.041] 	Module class: X.Org Server Extension
[    32.041] 	ABI class: X.Org Server Extension, version 6.0
[    32.041] (II) Loading extension RECORD
[    32.041] (II) LoadModule: "dri"
[    32.042] (II) Loading /usr/lib/xorg/modules/extensions/libdri.so
[    32.061] (II) Module dri: vendor="X.Org Foundation"
[    32.061] 	compiled for 1.12.3, module version = 1.0.0
[    32.061] 	ABI class: X.Org Server Extension, version 6.0
[    32.061] (II) Loading extension XFree86-DRI
[    32.061] (II) LoadModule: "dri2"
[    32.061] (II) Loading /usr/lib/xorg/modules/extensions/libdri2.so
[    32.069] (II) Module dri2: vendor="X.Org Foundation"
[    32.069] 	compiled for 1.12.3, module version = 1.2.0
[    32.069] 	ABI class: X.Org Server Extension, version 6.0
[    32.069] (II) Loading extension DRI2
[    32.070] (==) Matched ati as autoconfigured driver 0
[    32.070] (==) Matched fbdev as autoconfigured driver 1
[    32.070] (==) Assigned the driver to the xf86ConfigLayout
[    32.070] (II) LoadModule: "ati"
[    32.074] (II) Loading /usr/lib/xorg/modules/drivers/ati_drv.so
[    32.080] (II) Module ati: vendor="X.Org Foundation"
[    32.099] 	compiled for 1.12.1.902, module version = 6.14.4
[    32.099] 	Module class: X.Org Video Driver
[    32.099] 	ABI class: X.Org Video Driver, version 12.0
[    32.099] (II) LoadModule: "mach64"
[    32.100] (II) Loading /usr/lib/xorg/modules/drivers/mach64_drv.so
[    32.122] (II) Module mach64: vendor="X.Org Foundation"
[    32.122] 	compiled for 1.12.3, module version = 6.9.1
[    32.122] 	Module class: X.Org Video Driver
[    32.122] 	ABI class: X.Org Video Driver, version 12.0
[    32.128] (II) LoadModule: "fbdev"
[    32.128] (WW) Warning, couldn't open module fbdev
[    32.128] (II) UnloadModule: "fbdev"
[    32.128] (II) Unloading fbdev
[    32.128] (EE) Failed to load module "fbdev" (module does not exist, 0)
[    32.128] (II) MACH64: Driver for ATI Mach64 chipsets
[    32.128] (--) using VT number 7

[    32.132] (II) MACH64(0): Creating default Display subsection in  
Screen section
	"Default Screen Section" for depth/fbbpp 24/32
[    32.132] (==) MACH64(0): Depth 24, (--) framebuffer bpp 32
[    32.132] (==) MACH64(0): Using XAA acceleration architecture
[    32.132] (II) MACH64: Mach64 in slot 1:1:0 detected.
[    32.132] (II) Loading sub module "int10"
[    32.132] (II) LoadModule: "int10"
[    32.132] (II) Loading /usr/lib/xorg/modules/libint10.so
[    32.173] (II) Module int10: vendor="X.Org Foundation"
[    32.173] 	compiled for 1.12.3, module version = 1.0.0
[    32.173] 	ABI class: X.Org Video Driver, version 12.0
[    32.177] (II) Loading sub module "ddc"
[    32.177] (II) LoadModule: "ddc"
[    32.177] (II) Module "ddc" already built-in
[    32.177] (II) Loading sub module "vbe"
[    32.177] (II) LoadModule: "vbe"
[    32.177] (II) Loading /usr/lib/xorg/modules/libvbe.so
[    32.185] (II) Module vbe: vendor="X.Org Foundation"
[    32.185] 	compiled for 1.12.3, module version = 1.1.0
[    32.185] 	ABI class: X.Org Video Driver, version 12.0
[    32.185] (II) MACH64(0): VESA BIOS not detected
[    32.185] (II) UnloadSubModule: "vbe"
[    32.185] (II) Unloading vbe
[    32.185] (II) UnloadSubModule: "int10"
[    32.185] (II) Unloading int10
[    32.185] (II) MACH64(0): BIOS Data:  BIOSSize=0x8000, ROMTable=0x0114.
[    32.185] (II) MACH64(0): BIOS Data:  ClockTable=0x097C,  
FrequencyTable=0x0000.
[    32.185] (II) MACH64(0): BIOS Data:  LCDTable=0x0000.
[    32.185] (II) MACH64(0): BIOS Data:  VideoTable=0x0000,  
HardwareTable=0x015E.
[    32.185] (II) MACH64(0): BIOS Data:  I2CType=0x0F, Tuner=0x00,  
Decoder=0x00, Audio=0x0F.
[    32.185] (--) MACH64(0): ATI 3D Rage XL or XC graphics controller  
detected.
[    32.185] (--) MACH64(0): Chip type 4752 "GR", version 7, foundry  
TSMC, class 0, revision 0x00.
[    32.185] (--) MACH64(0): PCI bus interface detected;  block I/O  
base is 0xCC00.
[    32.185] (--) MACH64(0): ATI Mach64 adapter detected.
[    32.185] (!!) MACH64(0): For information on using the multimedia  
capabilities
	of this adapter, please see http://gatos.sf.net.
[    32.185] (--) MACH64(0): Internal RAMDAC (subtype 1) detected.
[    32.185] (==) MACH64(0): RGB weight 888
[    32.185] (==) MACH64(0): Default visual is TrueColor
....



It includes successful submodule unloads now:
[    32.185] (II) UnloadSubModule: "vbe"
[    32.185] (II) Unloading vbe
[    32.185] (II) UnloadSubModule: "int10"
[    32.185] (II) Unloading int10



Kind regards
Stephan Schreiber



[unloadsubmodule.patch (application/octet-stream, attachment)]

Added tag(s) patch. Request was from info@fs-driver.org to control@bugs.debian.org. (Thu, 06 Sep 2012 16:51:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#686152; Package src:xorg-server. (Thu, 06 Sep 2012 16:57:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Julien Cristau <jcristau@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Thu, 06 Sep 2012 16:57:06 GMT) Full text and rfc822 format available.

Message #21 received at 686152@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: Stephan Schreiber <info@fs-driver.org>, 686152@bugs.debian.org
Subject: Re: Bug#686152: xorg server 1.12.3: xf86UnloadSubModule() hangs, patch proposal
Date: Thu, 6 Sep 2012 18:53:15 +0200
[Message part 1 (text/plain, inline)]
On Thu, Sep  6, 2012 at 18:31:52 +0200, Stephan Schreiber wrote:

> 
> A patch proposal.
> 
Please check if this is still an issue in xorg-server 1.13.  For 1.12 I
think I'll just revert the commit that made UnloadSubModule do
something.

Cheers,
Julien
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#686152; Package src:xorg-server. (Fri, 07 Sep 2012 17:36:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stephan Schreiber <info@fs-driver.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. (Fri, 07 Sep 2012 17:36:06 GMT) Full text and rfc822 format available.

Message #26 received at 686152@bugs.debian.org (full text, mbox):

From: Stephan Schreiber <info@fs-driver.org>
To: 686152@bugs.debian.org
Subject: Bug#686152: xorg server 1.12.3: xf86UnloadSubModule() hangs, patch proposal
Date: Fri, 07 Sep 2012 19:33:14 +0200
I took a look at the most recent code in xorg's git repository  
(http://cgit.freedesktop.org/xorg/xserver/tree/).
All the functions which has been considered in this bug report do not  
differ from the ones of xorg-server 1.12.3:
hw/xfree86/common/xf86Helper.c: xf86UnloadSubModule()
hw/xfree86/loader/loadmod.c: UnloadModuleOrDriver(),  
UnloadSubModule(), RemoveChild(ModuleDescPtr()
with one exception that isn't relevant for our issue -  
UnloadModuleOrDriver() of 1.13 uses another function for log messages  
than 1.12.3.


I assume that the issue is also present on xorg-server 1.13.


Kind regards
Stephan Schreiber





Reply sent to Julien Cristau <jcristau@debian.org>:
You have taken responsibility. (Sun, 30 Sep 2012 12:21:08 GMT) Full text and rfc822 format available.

Notification sent to Stephan Schreiber <info@fs-driver.org>:
Bug acknowledged by developer. (Sun, 30 Sep 2012 12:21:08 GMT) Full text and rfc822 format available.

Message #31 received at 686152-close@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: 686152-close@bugs.debian.org
Subject: Bug#686152: fixed in xorg-server 2:1.12.4-1
Date: Sun, 30 Sep 2012 12:17:58 +0000
Source: xorg-server
Source-Version: 2:1.12.4-1

We believe that the bug you reported is fixed in the latest version of
xorg-server, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 686152@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Julien Cristau <jcristau@debian.org> (supplier of updated xorg-server package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Sun, 30 Sep 2012 12:47:00 +0200
Source: xorg-server
Binary: xserver-xorg-core xserver-xorg-core-udeb xserver-xorg-dev xdmx xdmx-tools xnest xvfb xserver-xephyr xserver-xfbdev xserver-xorg-core-dbg xserver-common
Architecture: source all amd64
Version: 2:1.12.4-1
Distribution: unstable
Urgency: low
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Changed-By: Julien Cristau <jcristau@debian.org>
Description: 
 xdmx       - distributed multihead X server
 xdmx-tools - Distributed Multihead X tools
 xnest      - Nested X server
 xserver-common - common files used by various X servers
 xserver-xephyr - nested X server
 xserver-xfbdev - Linux framebuffer device tiny X server
 xserver-xorg-core - Xorg X server - core server
 xserver-xorg-core-dbg - Xorg - the X.Org X server (debugging symbols)
 xserver-xorg-core-udeb - Xorg X server - core server (udeb)
 xserver-xorg-dev - Xorg X server - development files
 xvfb       - Virtual Framebuffer 'fake' X server
Closes: 686152 686153 687268 688908
Changes: 
 xorg-server (2:1.12.4-1) unstable; urgency=low
 .
   * New upstream stable release.
   * int10: fix pci_device_read_rom usage (closes: #686153).  Thanks, Stephan
     Schreiber!
   * Revert 'Unload submodules' (closes: #686152).  Seems to introduce a
     regression, let's try that again later.  Thanks, Stephan Schreiber!
   * Revert "fb: reorder Bresenham error correction to avoid overshoot".  Fixes
     regression introduced in 1.12.3.902 (fdo#54168, closes: #688908)
   * Add conflicts against obsolete evtouch input driver (hopefully closes:
     #687268)
Checksums-Sha1: 
 fa42149680f8e0e1f3d002090f6efd001818a21b 4095 xorg-server_1.12.4-1.dsc
 c0e52b1496d427501a2f6b8fea50d040c75bbdb9 7528611 xorg-server_1.12.4.orig.tar.gz
 46c0d2c61213f4cd56e4eae3dcb429f3a9f4aa14 86250 xorg-server_1.12.4-1.diff.gz
 f2f2eff5e872f7b6be858c72a06d8496e1dcbcb6 1395292 xserver-common_1.12.4-1_all.deb
 3a4c72a07276869f5d547ad10465239a3b801f01 1760856 xserver-xorg-core_1.12.4-1_amd64.deb
 a22d9ee71beb9689897e1c97d78c894ec9588f4b 867928 xserver-xorg-core-udeb_1.12.4-1_amd64.udeb
 3caac6d3e390f9626c9857687a7de518993bc79e 319512 xserver-xorg-dev_1.12.4-1_amd64.deb
 dc4af1c43bff38b8535f85123d2bcd369142147f 922338 xdmx_1.12.4-1_amd64.deb
 b68a0221818332801716193b56de3ce5b05ec12e 124862 xdmx-tools_1.12.4-1_amd64.deb
 291dfdaf15cb8a0624715c8070a6821883d9680f 820772 xnest_1.12.4-1_amd64.deb
 bd9605660122361007d01211da9f1be5142585b3 924498 xvfb_1.12.4-1_amd64.deb
 3e9fb925e89b910882c34b09caa8c183a0da3a13 1016988 xserver-xephyr_1.12.4-1_amd64.deb
 6549ab33bc039606b17516caaeeac5317c03c0e0 939124 xserver-xfbdev_1.12.4-1_amd64.deb
 5ffe7db47c7f19d73cd56a8848b0cfa633b0c89e 7290276 xserver-xorg-core-dbg_1.12.4-1_amd64.deb
Checksums-Sha256: 
 366e81898d685ffd1aa411e86b82164a362369242da4f5537bb9a15e0e809b6d 4095 xorg-server_1.12.4-1.dsc
 d88225cd3c4a6ecd92d1360b34a0e5b6346e2a04c842c018cef36d8a370714ef 7528611 xorg-server_1.12.4.orig.tar.gz
 63a0a859f006e21741b1d6b54b75c92db3da79b5352282a3d38e5678c841ca96 86250 xorg-server_1.12.4-1.diff.gz
 d983e82002caa52091e012079e9a0cc28b89949df15b187c3052e35924165bde 1395292 xserver-common_1.12.4-1_all.deb
 3199d0b71a31c4c8956155f203bd35c3c5a439a4c7bf9cf91094190c88dcc962 1760856 xserver-xorg-core_1.12.4-1_amd64.deb
 d433385006cfb0a6fa316d2f262f2ed6f3fab333dddcc21e29e76fb843f11afa 867928 xserver-xorg-core-udeb_1.12.4-1_amd64.udeb
 2e36af32590ed33e3d4283a32b3549498192fcb2809719c6a04274a316864b6b 319512 xserver-xorg-dev_1.12.4-1_amd64.deb
 6035bccb6d18fdb9448b1c698a7606a1e2dfb4782b50c95c97a94859851a3d67 922338 xdmx_1.12.4-1_amd64.deb
 76ccb05b4fadb922dfbdd8e0262cb198797f07bb5498e86949540b767d792f21 124862 xdmx-tools_1.12.4-1_amd64.deb
 fe50bc3da2f7ee0fe7fc86a49223a6f7ff5f88030ae8e215bf2988590dae9e0e 820772 xnest_1.12.4-1_amd64.deb
 371934833835e7b137019a1af34b855f5520706ba8a21ffbd315f7a1986eda76 924498 xvfb_1.12.4-1_amd64.deb
 15cba42a582e6a39ac4c8a41c427f754acc080adf1eba25a160861155c99de74 1016988 xserver-xephyr_1.12.4-1_amd64.deb
 0eb445e10acda9566e9f61d79bf80b2487b9584053f8f486f6c6cd181f9daff8 939124 xserver-xfbdev_1.12.4-1_amd64.deb
 bdf3434bf0799a1f9541f6b1db5ab701cc382f23479e95d9736b97fb2ec3ae5c 7290276 xserver-xorg-core-dbg_1.12.4-1_amd64.deb
Files: 
 7282071cf61c4e8dd052b37f4e13b1c3 4095 x11 optional xorg-server_1.12.4-1.dsc
 19c17bf7ac3e2ce34bc40108692c031f 7528611 x11 optional xorg-server_1.12.4.orig.tar.gz
 864664833a9cbce9d5c85a709b76eadf 86250 x11 optional xorg-server_1.12.4-1.diff.gz
 4e91bc8936fc826e11e61d59ffec92f7 1395292 x11 optional xserver-common_1.12.4-1_all.deb
 752c95c46cfc7e48be5963b53a830fde 1760856 x11 optional xserver-xorg-core_1.12.4-1_amd64.deb
 3808865604af60efb663b4d03ea2e1cb 867928 debian-installer optional xserver-xorg-core-udeb_1.12.4-1_amd64.udeb
 a519a1caac09f8ea44375090e7de274e 319512 x11 optional xserver-xorg-dev_1.12.4-1_amd64.deb
 0415e804f43e6e640fb304bedf176e06 922338 x11 optional xdmx_1.12.4-1_amd64.deb
 200ab28eebc30324e7c594d11753c395 124862 x11 optional xdmx-tools_1.12.4-1_amd64.deb
 600d862f5be724d50cb7798349845ccf 820772 x11 optional xnest_1.12.4-1_amd64.deb
 d22e78e902e3964c202b2e7575748325 924498 x11 optional xvfb_1.12.4-1_amd64.deb
 31181857da8a186b385302ee3fb3d484 1016988 x11 optional xserver-xephyr_1.12.4-1_amd64.deb
 5d94a4ad4f3a2d5f94d04024eb2d21e1 939124 x11 optional xserver-xfbdev_1.12.4-1_amd64.deb
 09889862b8e7d5ec0c2f784d30a5f36e 7290276 debug extra xserver-xorg-core-dbg_1.12.4-1_amd64.deb
Package-Type: udeb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCAAGBQJQaC2WAAoJEDEBgAUJBeQMEwgP/jJy7olloN7kcQnHjJE6IkZB
6PN+vjV/1WKa8gvs/MtQ4FTwMPEzWh9k5uKBcFDtZvPxpUxoeUgww1PyrVUZri+n
CzBZI2u417ff6BfOP/6CxFoCWBMhG+xJ0CHLHhmQB0lFTZ6JcJxBO8W/aBvZGugr
4I2/sBEoayBTS5ikPj+vMrkw8o1vTkrdTtpoLi1Z88RxofV/DQxceaD0kUBu0XGV
rWoVjZofpbVDfy3cwoB3lj0wHrwFaNM9p2acDu3EMJAa/TUgXW9BV4Z/SdBYfNTn
Jyfte38fKwn8w4L6pi87wPiwnnVE/xson1ddgt3FyA2Ps501y9vMu4ml1EDi4J8i
PxziODlCVK5QoZ1lpfnjijwBlRWtJfghP1N7ha2UsPu/kVXZewX8teeAjtNyco0l
HwTqqPKWEeNkf05W8ZaLBPOr9Nb+UaHEELTvTBysJums+7/hBEIyYYu4XEugaqD3
55jMJphSc1pd9X3TlOIuQBhzEtHeYLPwnAzd31GVFCdP1Af15BXvKVngxJQCPmxD
BmR5llYkJopf7GEFsSan8+hX+7WSYRfxEgh+zFv6t2pFZ603Xgmz5kPNr4yuJgrM
0j8ZNazJcEu0Y6gL5FSo9kXiC8GfaOKYkxvxnFxYQmZ/egWwfjOQgbdXMHBtp7qw
kJT4PxqfBY6cqpWItQFE
=qpZA
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 29 Oct 2012 07:28:13 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 23 16:07:03 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.